# coding: utf-8

"""
    Middleware

    Knowledge Graph data management.

    The version of the OpenAPI document: 1.0
    Contact: hello@wordlift.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from wordlift_client.models.rule_request import RuleRequest
from wordlift_client.models.webpage_properties import WebpageProperties
from typing import Optional, Set
from typing_extensions import Self

class SmartContentRequest(BaseModel):
    """
    SmartContentRequest
    """ # noqa: E501
    account_id: Annotated[int, Field(strict=True, ge=1)] = Field(description="The account id.")
    model_id: Optional[Annotated[int, Field(strict=True, ge=1)]] = Field(default=1, description="The model id.")
    rules: Optional[List[RuleRequest]] = None
    webpage_properties: Optional[List[WebpageProperties]] = None
    __properties: ClassVar[List[str]] = ["account_id", "model_id", "rules", "webpage_properties"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SmartContentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rules (list)
        _items = []
        if self.rules:
            for _item in self.rules:
                if _item:
                    _items.append(_item.to_dict())
            _dict['rules'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in webpage_properties (list)
        _items = []
        if self.webpage_properties:
            for _item in self.webpage_properties:
                if _item:
                    _items.append(_item.to_dict())
            _dict['webpage_properties'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SmartContentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_id": obj.get("account_id"),
            "model_id": obj.get("model_id") if obj.get("model_id") is not None else 1,
            "rules": [RuleRequest.from_dict(_item) for _item in obj["rules"]] if obj.get("rules") is not None else None,
            "webpage_properties": [WebpageProperties.from_dict(_item) for _item in obj["webpage_properties"]] if obj.get("webpage_properties") is not None else None
        })
        return _obj


